#include <nostub.h>
#include <all.h>

int _ti89;
char *_comment="Demo by Bobby Jackson 2000";

void box_func(void)
{
        LCD_BUFFER buffer;
        LCD_save(buffer);
        ClrScr();
        DrawStr(0,0,"Hardware release 2(y/n)?",A_REPLACE);
        if(!GrayMode (((ngetchx () | 32) =='y') ? GRAY_HW2 : GRAY_HW1)) return;
        SetPlane(0);
        ClrScr();
        ScrRectFill(&(SCR_RECT){20,20,40,40},ScrRect,A_NORMAL);
        ScrRectFill(&(SCR_RECT){40,20,60,40},ScrRect,A_NORMAL);
        SetPlane(1);
        ClrScr();
        ScrRectFill(&(SCR_RECT){20,40,40,60},ScrRect,A_NORMAL);
        ScrRectFill(&(SCR_RECT){40,40,60,60},ScrRect,A_NORMAL);
        ngetchx();
        GrayMode(GRAY_OFF);
        LCD_restore(buffer);
}

void trianglenorm_func(void)
{
        LCD_BUFFER buffer;
        LCD_save(buffer);
        ClrScr();
        DrawStr(0,0,"Hardware release 2(y/n)?",A_REPLACE);
        if(!GrayMode (((ngetchx() | 32)=='y') ? GRAY_HW2 : GRAY_HW1)) return;
        SetPlane(0);
        ClrScr();
        FillTriangle(40,20,20,40,40,40,&(SCR_RECT){0,0,160,100},A_NORMAL);
        FillTriangle(40,20,40,40,60,40,&(SCR_RECT){0,0,160,100},A_NORMAL);
        SetPlane(1);
        ClrScr();
        FillTriangle(20,40,40,40,40,60,&(SCR_RECT){0,0,160,100},A_NORMAL);
        FillTriangle(40,40,60,40,40,60,&(SCR_RECT){0,0,160,100},A_NORMAL);
        ngetchx();
        GrayMode(GRAY_OFF);
        LCD_restore(buffer);
}

void trianglevs_func(void)
{
        LCD_BUFFER buffer;
        LCD_save(buffer);
        ClrScr();
        DrawStr(0,0,"Hardware release 2(y/n)?",A_REPLACE);
        if(!GrayMode (((ngetchx() | 32)=='y') ? GRAY_HW2 : GRAY_HW1)) return;
        SetPlane(0);
        ClrScr();
        FillTriangle(40,20,20,40,40,40,&(SCR_RECT){0,0,160,100},A_SHADE_V);
        FillTriangle(40,20,40,40,60,40,&(SCR_RECT){0,0,160,100},A_SHADE_V);
        SetPlane(1);
        ClrScr();
        FillTriangle(20,40,40,40,40,60,&(SCR_RECT){0,0,160,100},A_SHADE_V);
        FillTriangle(40,40,60,40,40,60,&(SCR_RECT){0,0,160,100},A_SHADE_V);
        ngetchx();
        GrayMode(GRAY_OFF);
        LCD_restore(buffer);
}

void trianglehs_func(void)
{
        LCD_BUFFER buffer;
        LCD_save(buffer);
        ClrScr();
        DrawStr(0,0,"Hardware release 2(y/n)?",A_REPLACE);
        if(!GrayMode (((ngetchx() | 32)=='y') ? GRAY_HW2 : GRAY_HW1)) return;
        SetPlane(0);                                   
        ClrScr();
        FillTriangle(40,20,20,40,40,40,&(SCR_RECT){0,0,160,100},A_SHADE_H);
        FillTriangle(40,20,40,40,60,40,&(SCR_RECT){0,0,160,100},A_SHADE_H);
        SetPlane(1);
        ClrScr();
        FillTriangle(20,40,40,40,40,60,&(SCR_RECT){0,0,160,100},A_SHADE_H);
        FillTriangle(40,40,60,40,40,60,&(SCR_RECT){0,0,160,100},A_SHADE_H);
        ngetchx();
        GrayMode(GRAY_OFF);
        LCD_restore(buffer);
}

void trianglens_func(void)
{
        LCD_BUFFER buffer;
        LCD_save(buffer);
        ClrScr();
        DrawStr(0,0,"Hardware release 2(y/n)?",A_REPLACE);
        if(!GrayMode (((ngetchx() | 32)=='y') ? GRAY_HW2 : GRAY_HW1)) return;
        SetPlane(0);
        ClrScr();
        FillTriangle(40,20,20,40,40,40,&(SCR_RECT){0,0,160,100},A_SHADE_NS);
        FillTriangle(40,20,40,40,60,40,&(SCR_RECT){0,0,160,100},A_SHADE_NS);
        SetPlane(1);
        ClrScr();
        FillTriangle(20,40,40,40,40,60,&(SCR_RECT){0,0,160,100},A_SHADE_NS);
        FillTriangle(40,40,60,40,40,60,&(SCR_RECT){0,0,160,100},A_SHADE_NS);
        ngetchx();
        GrayMode(GRAY_OFF);
        LCD_restore(buffer);
}
        
        
void triangleps_func(void)
{
        LCD_BUFFER buffer;
        LCD_save(buffer);
        ClrScr();
        DrawStr(0,0,"Hardware release 2(y/n)?",A_REPLACE);
        if(!GrayMode (((ngetchx() | 32)=='y') ? GRAY_HW2 : GRAY_HW1)) return;
        SetPlane(0);
        ClrScr();
        FillTriangle(40,20,20,40,40,40,&(SCR_RECT){0,0,160,100},A_SHADE_PS);
        FillTriangle(40,20,40,40,60,40,&(SCR_RECT){0,0,160,100},A_SHADE_PS);
        SetPlane(1);
        ClrScr();
        FillTriangle(20,40,40,40,40,60,&(SCR_RECT){0,0,160,100},A_SHADE_PS);
        FillTriangle(40,40,60,40,40,60,&(SCR_RECT){0,0,160,100},A_SHADE_PS);
        ngetchx();
        GrayMode(GRAY_OFF);
        LCD_restore(buffer);
}

void ellipse_func(void)
{
        LCD_BUFFER buffer;
        LCD_save(buffer);
        ClrScr();
        DrawStr(0,0,"Hardware Release 2(y/n)",A_REPLACE);
        if(!GrayMode (((ngetchx() | 32)=='y') ? GRAY_HW2 : GRAY_HW1)) return;
        SetPlane(0);
        ClrScr();
        DrawClipEllipse(80,50,10,5,&(SCR_RECT){0,0,160,100},A_NORMAL);
        DrawClipEllipse(80,50,9,4,&(SCR_RECT){0,0,160,100},A_NORMAL);
        SetPlane(1);
        ClrScr();
        DrawClipEllipse(80,50,8,3,&(SCR_RECT){0,0,160,100},A_NORMAL);
        DrawClipEllipse(80,50,7,2,&(SCR_RECT){0,0,160,100},A_NORMAL);
        ngetchx();
        GrayMode(GRAY_OFF);
        LCD_restore(buffer);
}

void circle_func(void)
{
        LCD_BUFFER buffer;
        LCD_save(buffer);
        ClrScr();
        DrawStr(0,0,"Hardware Release 2(y/n)",A_REPLACE);
        if(!GrayMode (((ngetchx() | 32)=='y') ? GRAY_HW2 : GRAY_HW1)) return;
        SetPlane(0);
        ClrScr();
        DrawClipEllipse(80,50,10,10,&(SCR_RECT){0,0,160,100},A_NORMAL);
        DrawClipEllipse(80,50,9,9,&(SCR_RECT){0,0,160,100},A_NORMAL);
        SetPlane(1);
        ClrScr();
        DrawClipEllipse(80,50,8,8,&(SCR_RECT){0,0,160,100},A_NORMAL);
        DrawClipEllipse(80,50,7,7,&(SCR_RECT){0,0,160,100},A_NORMAL);
        ngetchx();
        GrayMode(GRAY_OFF);
        LCD_restore(buffer);
}

int _main(void)
{
        unsigned int handle,result,exec_handle,diag;
        handle=MenuNew(2,160,18);
        MenuAddText(handle,0,"Main",1,0);
        MenuAddText(handle,1,"Rectangle",2,0);
        MenuAddText(handle,1,"Circle",10,0);
        MenuAddText(handle,1,"Ellipse",11,0);
        MenuAddText(handle,1,"About",12,0);
        MenuAddText(handle,0,"Triangle",3,0);
        MenuAddText(handle,3,"Normal",4,0);
        MenuAddText(handle,3,"Vertically Shaded",5,0);
        MenuAddText(handle,3,"Horizontally Shaded",6,0);
        MenuAddText(handle,3,"Negative Slope",7,0);
        MenuAddText(handle,3,"Positive Slope",8,0);
        MenuAddText(handle,1,"Exit",9,0);
        exec_handle=MenuBegin(HeapDeref(handle),0,0,0);
        while(result!=9)
        {     
                ST_busy(ST_IDLE);
                ST_helpMsg("Little demo by Bobby Jackson 2000.");
                result=MenuKey(exec_handle,ngetchx());
                switch(result)
                {
                        case 2:
                                box_func();
                                break;
                        case 4:
                                trianglenorm_func();
                                break;
                        case 5:
                                trianglevs_func();
                                break;
                        case 6:
                                trianglehs_func();
                                break;
                        case 7:
                                trianglens_func();
                                break;
                        case 8:
                                triangleps_func();
                                break;
                        case 10:
                                circle_func();
                                break;
                        case 11:
                                ellipse_func();
                                break;
                        case 12:
                                diag=DialogNewSimple(150,55);
                                DialogAddText(diag,5,13,"Graphics Demo");
                                DialogAddText(diag,5,20,"By Bobby Jackson in 2000");
                                DialogAddText(diag,5,27,"This demo demonstrates graphics");
                                DialogAddText(diag,5,34,"grayscale, menus, and dialogs");
                                DialogAddTitle(diag,"About this demo.",BT_OK,BT_NONE);
                                result=DialogDo(diag,CENTER,CENTER,NULL,NULL);
                                break;
                }
        }

        MenuEnd(exec_handle);
        HeapFree(handle);
        MenuUpdate();
}

